#include "MenuItemStoredValue.h"
#pragma once

  private delegate void MenuItemSelectedEventHandler(System::Object^ sender, MenuItemSelectedEventArgs^ e);

  /// <summary>
  /// Summary for ComboMenuStrip
  /// </summary>
  public ref class ComboMenuStrip : public System::Windows::Forms::MenuStrip
  {
    //variables
  private:
    /// <summary>
    /// Required designer variable.
    /// </summary>
    System::ComponentModel::Container ^components;
    System::Windows::Forms::MouseEventArgs^ cached_mouse_move;
    System::Windows::Forms::ToolTip^ tool_tip; 

    bool setBaseItemOnClick_;

    //functions
  private:
    void InitializeComponent();

  protected:
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    ~ComboMenuStrip();

    virtual void WndProc(System::Windows::Forms::Message %pmsg) override;
    virtual void OnPaint(System::Windows::Forms::PaintEventArgs ^e) override;
    virtual void OnClick(System::EventArgs ^e) override;

  internal: 

    void setBaseMenuItem(MenuItemStoredValue^ base_menu_item);
    MenuItemStoredValue^ getBaseMenuItem();
    void setSelection(MenuItemStoredValue^ menu_item);

    //events
    event MenuItemSelectedEventHandler ^menuSelected;

  public:
    //constructers
    ComboMenuStrip();

    //Event handler for the menu items
    void clickMenu(System::Object ^sender, System::EventArgs ^e);

    void setItemOnClick(bool flag) {setBaseItemOnClick_ = flag;}



  };

