#pragma once


#include "MenuItemVariable.h"

public ref class MenuItemSelectedEventArgs
{
private:
  System::String^ display_name_;
  MenuItemVariable* stored_menu_variable_;
  int row_;
  int column_;

public:
  // Constructor
  MenuItemSelectedEventArgs();
  const MenuItemSelectedEventArgs(System::String^ display_name,MenuItemVariable* menu_variable);
  const MenuItemSelectedEventArgs(System::String^ display_name,MenuItemVariable* menu_variable,int column,int row);

  void setDisplayName(System::String^ display_name);
  System::String^ getDisplayName();

  void setMenuVariable(MenuItemVariable* menu_variable);
  MenuItemVariable* getMenuVariable();

  void setColumn(int column);
  int getColumn();

  void setRow(int row);
  int getRow();

};
