#pragma once

#include "MenuItemVariable.h"
#include "MenuItemSelectedEventArgs.h"

//extend the ToolStripMenuItem class to include a UniqueTag member
ref class MenuItemStoredValue : public System::Windows::Forms::ToolStripMenuItem
{
public:

  //variables
private:

  //the display name to use if the item is selected
  System::String^    display_name_;

  //the item to store
  MenuItemVariable *item_stored_;

protected:

public:

  //Functions
private:
  System::Void InitializeComponent() {
  }

protected:

public:
  MenuItemStoredValue();
  MenuItemStoredValue(System::String^ text);
  MenuItemStoredValue(System::String^ text,MenuItemVariable* item);
  MenuItemStoredValue(System::String^ text,MenuItemVariable::StoredType stored_type);
  MenuItemStoredValue(MenuItemStoredValue^ old);
  ~MenuItemStoredValue();

  //ACCESS FUNCTIONS
  MenuItemVariable*        getItemStored();
  void                     setItemStored(MenuItemVariable* item);
  System::String^          getDisplayName();
  void                     setDisplayName(System::String^ display_name);

  bool                     hasValidItemStored();

  // FUNCTIONS FROM GridCellRendererBase
  virtual void OnPaint(System::Windows::Forms::PaintEventArgs ^e) override;
};
