#include "StdAfx.h"
#include "MenuItemSelectedEventArgs.h"
/******************************************************************
MenuItemSelectedEventArgs: Constructor
*******************************************************************/

MenuItemSelectedEventArgs::MenuItemSelectedEventArgs() {
  column_=0;
  row_=0;
  stored_menu_variable_=nullptr;
  display_name_=nullptr;
}

MenuItemSelectedEventArgs::MenuItemSelectedEventArgs(System::String^ display_name,MenuItemVariable* menu_variable) {
  column_=0;
  row_=0;
  stored_menu_variable_=menu_variable;
  display_name_=display_name;
}

MenuItemSelectedEventArgs::MenuItemSelectedEventArgs(System::String^ display_name,MenuItemVariable* menu_variable, int column,int row) {
  column_=column;
  row_=row;
  stored_menu_variable_=menu_variable;
  display_name_=display_name;
}

/******************************************************************
MenuItemSelectedEventArgs: Getters and setters
*******************************************************************/
void 
MenuItemSelectedEventArgs::setDisplayName(System::String^ display_name) {
  display_name_=display_name;
}


System::String^
MenuItemSelectedEventArgs:: getDisplayName()
{
  return display_name_;
}

void 
MenuItemSelectedEventArgs::setMenuVariable(MenuItemVariable* menu_variable) {
  stored_menu_variable_=menu_variable;
}


MenuItemVariable*
MenuItemSelectedEventArgs:: getMenuVariable()
{
  return stored_menu_variable_;
}

void 
MenuItemSelectedEventArgs::setColumn(int column)  {
  column_=column;
}

int 
MenuItemSelectedEventArgs::getColumn()  {
  return column_;
}

void 
MenuItemSelectedEventArgs::setRow(int row)  {
  row_=row;
}

int 
MenuItemSelectedEventArgs::getRow()  {
  return row_;
}
