#include "StdAfx.h"
#include "SumCalMenu.h"

#include "UiMenuListCell.h"
/*#include <Sim/UiSubjectSim/CaseVarParser.h>
#include <Sim/UiSubjectSim/IdentifierVarParser.h>
#include <Sim/UiSubjectSim/NewCaseInput.h>
#include <Sim/UiSubjectSim/NewVectorInput.h>
#include <Sim/UiSubjectSim/SimulationVarParser.h>
#include <Sim/UiSubjectSim/SumCalMenuTable.h>
#include <Sim/UiSubjectSim/SourceDataVarParser.h>
#include <Sim/UiSubjectSim/UiMenuListCell.h>
#include <Sim/UiSubjectSim/VariableVarParser.h>
#include <Sim/UiSubjectSim/VectorVarParser.h>
*/

/*#include <mod/SubjectCases/CasesTree.h>
#include <mod/SubjectCases/GenericCategory.h>
#include <mod/SubjectCases/GenericPropIdsSubject.h>*/

/*#include <core/PrimUtility/TimeException.h>
#include <core/PrimUtility/TimeFormat.h>
#include <core/PrimUtility/TimeParser.h>

#include <core/SubjectBase/RefFolder.h>
#include <core/SubjectBase/RefSubject.h>
#include <core/SubjectBase/RootSubject.h>
#include <core/SubjectBase/TemplateSubject.h>

#include <core/SubjectShapes/SurfaceSubject.h>*/

using namespace System;
using namespace Syncfusion::Windows::Forms::Grid;

/******************************************************************
SumCalMenuTable: Constructor.
******************************************************************/

SumCalMenuTable::SumCalMenuTable() {
  lhs_variable_present_ = false;
  //variables_ = new BaseVector<SummaryCalculatorVariable::Ptr>;
}

SumCalMenuTable::~SumCalMenuTable() {
  /*if(variables_ != NULL)
    variables_->clear(true);
  delete variables_;
  variables_ = NULL;*/
}

/******************************************************************
SumCalMenuTable: FUNCTION FROM UiTable
******************************************************************/

void
SumCalMenuTable::onInitialize() {

  //initialise grid properties
  this->AllowSelection=GridSelectionFlags::None;
  this->ShowCurrentCellBorderBehavior=GridShowCurrentCellBorder::HideAlways;

  //add the new cell model 
  CellModels->Add("CaseMenuCell", gcnew UiMenuListCell(this->Model));
  initialiseMenuStripControls();

  //BOLC TEMP add event handler to the location changed event
  menu_combo_active_->LocationChanged += gcnew EventHandler(this,&SumCalMenuTable::locationChanged);

  //initialise the cell renderer
  UiMenuListCellRenderer^ cell_renderer = dynamic_cast<UiMenuListCellRenderer^>(this->CellRenderers["CaseMenuCell"]);
  
  if(cell_renderer)
    cell_renderer->InitCellPanels(menu_combo_active_, menu_combo_draw_);

  //register the item selected event handler
  cell_renderer->itemSelected +=gcnew MenuItemSelectedEventHandler(this,&SumCalMenuTable::itemSelected);

  this->ResizingColumns += gcnew Syncfusion::Windows::Forms::Grid::GridResizingColumnsEventHandler(this, &SumCalMenuTable::gridResizingColumns);

  resetFilters();
}

//BOLC TEMP
void
SumCalMenuTable::locationChanged(System::Object^ sender, EventArgs^ event_args)  {
  System::Drawing::Point^ location = menu_combo_active_->Location;
  Debug::Write("X = " + System::Convert::ToString(location->X)+ "\n");
  Debug::Write("Y = " + System::Convert::ToString(location->Y) + "\n");
  //msDebug("X = " + System::Convert::ToString(location->X));
  //msDebug("Y = " + System::Convert::ToString(location->Y));
}



/******************************************************************
SumCalMenuTable: PUBLIC METHODS
******************************************************************/

//creates the header row with appropriate text and sets the column widths
/*void
SumCalMenuTable::makeHeaders() {

  //  bool 	was_locked          = lockUpdate(true);

  this->ColCount = int(SumCols::IDENTIFIER);

  const int ROW = 0;

  makeHeader(ROW, int(SumCols::BLANK), "", "", CELL_WIDTH, styles::HALIGN_CENTER);
  makeHeader(ROW, int(SumCols::VARIABLE), "Variable", "", CELL_WIDTH, styles::HALIGN_CENTER);
  makeHeader(ROW, int(SumCols::CASE), "Source", "", CELL_WIDTH, styles::HALIGN_CENTER);
  makeHeader(ROW, int(SumCols::VECTOR), "Vector", "", CELL_WIDTH, styles::HALIGN_CENTER);
  makeHeader(ROW, int(SumCols::IDENTIFIER), "Identifier", "", CELL_WIDTH, styles::HALIGN_CENTER);

  SetColWidth(int(SumCols::BLANK),int(SumCols::BLANK),0);
  SetColWidth(int(SumCols::VARIABLE), int(SumCols::IDENTIFIER), CELL_WIDTH);

  SetRowHeight(ROW,ROW,CELL_HEIGHT);
  //  lockUpdate(was_locked);
}
*/

/*
void
SumCalMenuTable::makeHeader(int row, int col, System::String^ label, System::String^ tooltip, int width) {

  setStyleRange(UiTableRange::cell(row, col), UiTableStyle(nullptr)
    .setValue(label)
    .setInterior(uiColorKit::getButtonColor())
    .setFontBold(true));

  if (row == 0)
    SetColWidth(col, col, width);

  SetRowHeight(row, row, CELL_HEIGHT);
}
*/

/*void
SumCalMenuTable::setStyleRange(UiTableRange ^range, UiTableStyle style) {
  if (range == nullptr)
    return;

  ChangeCells(range, style.getStyle()); 
}*/



void 
SumCalMenuTable::clearTable() {

  // Clear the table and make the headers.
  RowCount = 0;
  ColCount = 0;
  //makeHeaders();
}

//input a vector of arguments which in turn populate the rows in the table
bool 
//SumCalMenuTable::populateTable(const SummaryCalculatorExpression::Ptr input_expression, const SummaryCalculatorExpression::Ptr previous_expression,bool lhs_variable_present, bool is_workflow) {
SumCalMenuTable::populateTable() {

  //resetting the table
  RowCount=3;
  ColCount=3;

  this->ColWidths[2] = 200;
  this->ColWidths[3] = 200;
  this->RowHeights[2] = 50;

  GridStyleInfo ^style;
  style = this[2, 2];
  style->CellType = "CaseMenuCell";
  style = this[2, 3];
  style->CellType = "CaseMenuCell";


  return true;


  //makeHeaders();
  //lhs_variable_present_=lhs_variable_present;
  //is_workflow_=is_workflow;

  //  bool 	was_locked = lockUpdate(true);

  //insert each row in the expression
/*  for (int i = 0 ; i < input_expression->getNoVariables() ; i++) {
    insertVariableRow(SummaryCalculatorVariable::duplicate(input_expression->getVariableAt(i)), previous_expression);
  }

  //reapply the filters to the new menus if not empty string
  if(current_case_filter_ != "")
    applyFilter((int)SumCols::CASE);
  if(current_vector_filter_ != "")
    applyFilter((int)SumCols::VECTOR);
  if(current_identifier_filter_ != "")
    applyFilter((int)SumCols::IDENTIFIER);

  //  lockUpdate(was_locked);
  this->Refresh();

  //test if all the variables have been selected 
  if(isAllSelected()) {
    return true;
  }else {
    return false;
  }*/
}

/*bool 
SumCalMenuTable::getCurrentExpression(SummaryCalculatorExpression::Ptr calc_expression) {

  calc_expression->resetExpression();

  for(int i = 1 ; i <= this->RowCount ; i++  ) {
    ASSERT(1<=i && i<=this->RowCount);

    //get the case, vector and identifier styles for this row
    getStyles(i);
    MenuItemVariable *case_var = sp_case_->BaseMenu->getItemStored();
    MenuItemVariable *vector_var = sp_vector_->BaseMenu->getItemStored();
    MenuItemVariable *identifier_var = sp_identifier_->BaseMenu->getItemStored();

    SummaryCalculatorVariable::Ptr variable = SummaryCalculatorVariable::create(getString(i,int(SumCols::VARIABLE)));

    if(case_var->getStoredType() == MenuItemVariable::StoredType::UNIQUE_TAG) {
      variable->setCaseTag(*case_var->getUniqueTag());
      variable->setSourceCat(case_var->getSourceCatValue());

    }else if(case_var->getStoredType() == MenuItemVariable::StoredType::NEW_CASE)  {
      NewCaseVariable new_case = case_var->getNewCaseVar();
      calc_expression->setNewCaseData(new_case.getCaseName(),new_case.getFolderName(),new_case.getRefCaseUniqueTag());

    }else if(case_var->getStoredType() == MenuItemVariable::StoredType::VARIABLE) {

      //the ref subject will be looked up during processing and the source set from that
      variable->setCaseTag(*case_var->getUniqueTag());
      variable->setSourceCat(NULL);

    }else if(case_var->getStoredType() == MenuItemVariable::StoredType::FOLDER) {
      variable->setUseAllInCaseFolder(true);
      variable->setCaseTag(*case_var->getUniqueTag());

      //we can only select case folders (not observed) so....
      GenericPropIdsSubject *dictionary = GenericPropIdsSubject::getInstance();
      ASSERT(dictionary != NULL);
      if (dictionary == NULL)
        return false;
      const GenericCategory *source_category = dictionary->getCategory("Source");
      const GenericCategory *sim_category = source_category->getSubCategory("Simulation");
      const GenericCategoryValue *source_cat_value=sim_category->getValue("Simulated");
      variable->setSourceCat(source_cat_value);
    }else if(case_var->getStoredType() == MenuItemVariable::StoredType::FLOWCONTROL)  {

      variable->setCaseTag(*case_var->getUniqueTag());
      variable->setSourceCat(case_var->getSourceCatValue());
    }

    if(vector_var->getStoredType() == MenuItemVariable::StoredType::GENERIC_PROP_ID)  {
      variable->setGenericPropId(vector_var->getGenericPropId());
    }else if(vector_var->getStoredType() == MenuItemVariable::StoredType::NEW_VECTOR) {

      //store the new vector details - the vector is not created here as this function will be 
      //called each time the parse button is clicked. 
      NewVectorVariable new_vector = vector_var->getNewVectorVar();
      calc_expression->setNewVectorData(new_vector.getVectorName(),new_vector.getTemplateUniqueTag());
    }

    if(identifier_var->getStoredType() == MenuItemVariable::StoredType::GENERIC_CAT_VALUE)  {
      variable->setIdentifierCat(identifier_var->getGenericCatValue());
    }else if(identifier_var->getStoredType() == MenuItemVariable::StoredType::VARIABLE) {
      variable->setIdentifierRefTag(*identifier_var->getUniqueTag());
    }else if(identifier_var->getStoredType() == MenuItemVariable::StoredType::FOLDER) {
      variable->setUseAllInIdentifierFolder(true);
      variable->setIdentifierRefTag(*identifier_var->getUniqueTag());
    }

    calc_expression->addVariable(variable);
    clearStyles();
  }

  if(isAllSelected()) {
    return true;
  }else {
    return false;
  }

}
*/
System::String^
SumCalMenuTable::getString(int row, int col) {

  Object ^obj = getValueRowCol(row, col);
  if (obj == nullptr)
    return String::Empty;

  return System::Convert::ToString(obj, System::Globalization::CultureInfo::InvariantCulture);
}

System::Object^
SumCalMenuTable::getValueRowCol(int row, int col) {

  return Model[row, col]->CellValue;
}

void 
SumCalMenuTable::applyFilters(System::String^ case_filter,System::String^ vector_filter,System::String^ identifier_filter)  {

  //msAddCursor(ms::WAIT);

  //only apply the filters if they have changed
  if(case_filter != current_case_filter_) {
    current_case_filter_ = case_filter;
    applyFilter((int)SumCols::CASE);
  }

  if(vector_filter != current_vector_filter_) {
    current_vector_filter_ = vector_filter;
    applyFilter((int)SumCols::VECTOR);
  }

  if(identifier_filter != current_identifier_filter_) {
    current_identifier_filter_ = identifier_filter;
    applyFilter((int)SumCols::IDENTIFIER);
  }
}

/******************************************************************
SumCalMenuTable: PRIVATE METHODS
******************************************************************/
void 
SumCalMenuTable::applyFilter(int col_index) {

  //ensure that there are rows to apply the filter to
  if(this->RowCount < 1)
    return;

  //apply the filter to each row
  for(int i = 1 ; i <= this->RowCount ; i++  ) {
    applyFilter(col_index,i);
  }
}

void 
SumCalMenuTable::applyFilter(int col, int row) {

  /*getStyles(row);
  GridStyleInfo^ style = this[row,col];
  ASSERT(style != nullptr)  ;
  if(style == nullptr)
    return;

  bool filter_column = false;

  switch(col) {
    case(int(SumCols::CASE)):

      if(style_case_->Enabled)  {
        setCaseColumnMenu(row);
      }

      break;
    case(int(SumCols::VECTOR)):

      if(style_vector_->Enabled)  {

        if(sp_case_->Master == (int)MasterCol::IDENTIFIER && !(lhs_variable_present_ && (row == 1))) {
          filter_column = true;
        }

        setVectorColumnMenu(filter_column,false,(row == 1 && lhs_variable_present_));
      }

      break;
    case(int(SumCols::IDENTIFIER)):

      if(style_identifier_->Enabled)  {

        if(sp_case_->Master == (int)MasterCol::VECTOR && !(lhs_variable_present_ && (row == 1))) {
          filter_column = true;
        }

        setIdentifierColumnMenu(filter_column,false,row);
      }

      break;
    default:
      //should never get here, can only filter the first three rows
      ASSERT(false);
      break;
  }

  clearStyles();*/
}

void 
SumCalMenuTable::resetFilters() {
  current_case_filter_       = gcnew System::String("");
  current_vector_filter_     = gcnew System::String("");
  current_identifier_filter_ = gcnew System::String("");
}

void
SumCalMenuTable::setBasicCellStyle(GridStyleInfo^ style)  {
  style->Enabled=true;
  style->AutoSize=false;
  style->CellType="CaseMenuCell";
}


//creates the appropriate type of combo list for the column.
//Initialises the menu items and the tooltip 
void 
SumCalMenuTable::makeComboMenuListRow(int row)
{
  /*getStyles(row);

  //set the basic styles of the cells
  setBasicCellStyle(style_case_);
  setBasicCellStyle(style_vector_);
  setBasicCellStyle(style_identifier_);

  //set the case column
  setCaseColumnMenu(row);

  //set the vector column
  if((row == 1 && lhs_variable_present_))  {
    setVectorColumnMenu(false, true, true);
  }else {
    style_vector_->Enabled = false;
    setVectorColumnMenu(false, true, false);
  }

  //set the identifier column
  if(!(row == 1 && lhs_variable_present_))  {
    style_identifier_->Enabled = false;
  }
  setIdentifierColumnMenu(false, true,row);

  //set the tooltips to default - these will be changed to the selections made as the user progresses
  setStyleRange(UiTableRange::cell(row, int(SumCols::CASE)), UiTableStyle(nullptr)
    .setTooltip(CASE_DEFAULT_TOOL_TIP));
  setStyleRange(UiTableRange::cell(row, int(SumCols::VECTOR)), UiTableStyle(nullptr)
    .setTooltip(VECTOR_DEFAULT_TOOL_TIP));
  setStyleRange(UiTableRange::cell(row, int(SumCols::IDENTIFIER)), UiTableStyle(nullptr)
    .setTooltip(IDENTIFIER_DEFAULT_TOOL_TIP));

  clearStyles();*/
}



//function called when a menu item has been clicked. The selected cell is altered and all rows
//which do not have a current selection for that column are also selected
void 
SumCalMenuTable::itemSelected(System::Object^ sender, MenuItemSelectedEventArgs^ event_args) {

  //msAddCursor(ms::WAIT);

  //  bool 	was_locked = lockUpdate(true);

  bool reset = false;
  //store if this is a reset event
  //if(event_args->getMenuVariable()->getStoredType() == MenuItemVariable::StoredType::RESET) {
//    reset = true;
//  }

  //itemSelectedAction(event_args->getRow(),event_args->getColumn(), event_args->getMenuVariable(), true);

  //do not propagate reset events
  //if(!reset)  {
  //  propagateSelection(event_args->getRow(),event_args->getColumn(),event_args->getMenuVariable());
  //}

  //lockUpdate(was_locked);
  this->Refresh();

  //test if all the variables have been selected fully - raise event to enable/disable the execute button
  SumCalMenuSelectedArgs^ args = gcnew SumCalMenuSelectedArgs(isAllSelected());
  itemsSelected(this,args);
}

//user has selected an item - select the same for all rows which 
// 1. have not had that column set
// 2. have the same selection in it's menu tree
// 3. are enabled
// If this is a 'New Case' or a 'New Vector' menu click then do not propagate selection as this is only valid
//for the LHS column
/*void
SumCalMenuTable::propagateSelection(int row,int col,MenuItemVariable *menu_item)  {

  //must have rows to propagate to
  if(this->RowCount <= 1)
    return;

  //we can not propagate the case column of the first row if it is a LHS as it will 
  //have a different type of unique tag (case not simulation) UNLESS it of FOLDER
  //type 
  if(row == 1 && lhs_variable_present_ && col == (int)SumCols::CASE && !(menu_item->getStoredType() == MenuItemVariable::StoredType::FOLDER))
    return;

  if(menu_item->getStoredType() == MenuItemVariable::StoredType::NEW_VECTOR)
    return;

  BaseMenuCellStyleProperties^ sp;
  GridStyleInfo^ style;

  //for each row in the table that is not the already selected row
  for(int i = 1; i <= this->RowCount ; i++) {

    if(i == row)
      continue;

    style=this[i,col];
    sp = gcnew BaseMenuCellStyleProperties(style);

    if(!style->Enabled)
      continue;

    if(sp->hasVariableSet())
      continue;

    bool selected = sp->setSelection(*menu_item);

    if(selected) 
      itemSelectedAction(i, col,menu_item,false);
  }
}*/

bool 
SumCalMenuTable::isAllSelected()  {

  //for all the rows in the table...
  for(int i = 1 ; i <= this->RowCount ; i++) {
    if(!isRowSelected(i))
      return false;
  }

  return true;
}

bool 
SumCalMenuTable::isRowSelected(int row)  {

  //sanity check

  if(row > this->RowCount)
    return false;

  //ensure that all three columns have an item set
  if(!isItemSelected(row,int(SumCols::CASE)))
    return false;

  if(!isItemSelected(row,int(SumCols::VECTOR)))
    return false;

  if(!isItemSelected(row,int(SumCols::IDENTIFIER)))
    return false;

  return true;
}

bool 
SumCalMenuTable::isItemSelected(int row, int col) {
  GridStyleInfo^ style               = this[row,col];
  //BaseMenuCellStyleProperties^ sp    = gcnew BaseMenuCellStyleProperties(style);
  //return sp->hasVariableSet();
  return false;
}



//the action taken when an item is selected. This can be either when the user clicks the 
//item or when the user has clicked an item in one row and this selection is repeated for all
//rows where no current selection has been made
/*void 
SumCalMenuTable::itemSelectedAction(int row, int col,MenuItemVariable *clicked_menu_item_var, bool pop_up_dialogs) {

  //set the styles from the table
  getStyles(row);

  MenuItemVariable *item_var;

  switch (col) {

    case int(SumCols::CASE):

      //if this is a new case...
      if(clicked_menu_item_var->getStoredType() == MenuItemVariable::StoredType::NEW_CASE)  {

        item_var = sp_case_->BaseMenu->getItemStored();

        //dialogs are show if this is a click event in the table rather than restoring the
        //users previous selections from a subsequent parse
        if(pop_up_dialogs)  {
          NewCaseInput^ input_dialog = gcnew NewCaseInput(item_var);
          bool ok = input_dialog->execute();

          //if the user has clicked cancel then exit the function
          //no data changes have been made to this point
          if(!ok)
            return;

          item_var->setNewCaseVar(*(input_dialog->getNewCaseVariable()));
        }

        //new case has been set via a pointer in the dialog or has been passed in from restoring selection
        NewCaseVariable new_case = item_var->getNewCaseVar();
        sp_case_->BaseMenu->setDisplayName(gcnew System::String(new_case.getCaseName()));
        sp_case_->BaseMenu->Text=gcnew System::String(new_case.getCaseName());
      }

      //if this is the first row and this is a LHS we must propagate
      //the all in folder selection. If an all in folder item has been selected then the 
      //corresponding item will be made visible in the subsequent rows. If an all in folder item
      //has not been selected then all all in folder items will be made invisible in subsequent rows
      if(row==1 && lhs_variable_present_ && !is_workflow_)  {
        propagateAllInFolderSelection(int(SumCols::CASE));
      }

      //the vector and identifier columns will not be enabled initially
      if(!style_vector_->Enabled || !style_identifier_->Enabled)
        style_vector_->Enabled = true;

      if(!style_identifier_->Enabled)
        style_identifier_->Enabled = true;


      //if this is a LHS variable then we do not filter the columns
      if(!(row == 1 && lhs_variable_present_)) {

        switch (sp_case_->Master) {
    case (int)MasterCol::NONE:

      setVectorColumnMenu(false,true,false);
      setIdentifierColumnMenu(false,true,row);
      break;

    case (int)MasterCol::VECTOR:

      setVectorColumnMenu(false,false,false);
      setIdentifierColumnMenu(true,false,row);
      break;

    case (int)MasterCol::IDENTIFIER:

      setIdentifierColumnMenu(false,false,row);
      setVectorColumnMenu(true,false,false);
      break;

    default:

      //should not default to this case
      ASSERT(false);
      setVectorColumnMenu(false,false,false);
      setIdentifierColumnMenu(false,false,row);
        }
      }

      break;

    case int(SumCols::VECTOR):

      //if this is a new case...
      if(clicked_menu_item_var->getStoredType() == MenuItemVariable::StoredType::NEW_VECTOR)  {

        item_var = sp_vector_->BaseMenu->getItemStored();

        //dialogs are show if this is a click event in the table rather than restoring the
        //users previous selections from a subsequent parse
        if(pop_up_dialogs)  {
          NewVectorInput^ input_dialog = gcnew NewVectorInput(item_var);
          bool ok = input_dialog->execute();

          //if the user has clicked cancel then exit the function
          //no data changes have been made to this point
          if(!ok)
            return;

          item_var->setNewVectorVar(*(input_dialog->getNewVectorVariable()));
        }

        //new case has been set via a pointer in the dialog or has been passed in from restoring selection
        NewVectorVariable new_vector = item_var->getNewVectorVar();
        sp_vector_->BaseMenu->setDisplayName(gcnew System::String(new_vector.getVectorName()));
        sp_vector_->BaseMenu->Text=gcnew System::String(new_vector.getVectorName());

        //in this case we are assured that this is the first row with a LHS present so 
        //can safely exit with no further filtering to be done
        return;
      }

      if(sp_case_->Master == (int)MasterCol::NONE)
        sp_case_->Master = (int)MasterCol::VECTOR;


      //if the vector column has a menu item selected 
      //user has selected the 'reset..' option. Unfilter both columns and clear selection
      if(!sp_vector_->hasVariableSet())  {
        resetVectorIdentifier(row);
        break;
      }


      //if the vector is the master filter the identifier
      //NB we do not filter the columns in the case that there is a LHS variable and this is row 1
      //the user can create vectors which do not currently exist in a case
      if(sp_case_->Master == (int)MasterCol::VECTOR) {
        if(!(lhs_variable_present_ && (row == 1)))
          setIdentifierColumnMenu(true,false,row);
      }

      break;

    case int(SumCols::IDENTIFIER):

      if(sp_case_->Master == (int)MasterCol::NONE)
        sp_case_->Master = (int)MasterCol::IDENTIFIER;


      //if this is the first row and this is a LHS we must propagate
      //the all in folder selection. If an all in folder item has been selected then the 
      //corresponding item will be made visible in the subsequent rows. If an all in folder item
      //has not been selected then all all in folder items will be made invisible in subsequent rows
      if(row==1 && lhs_variable_present_ && !is_workflow_)  {
        propagateAllInFolderSelection(int(SumCols::IDENTIFIER));
      }

      //if the identifier column has a menu item selected with null unique unique tag
      //user has selected the 'reset..' option. Unfilter both columns
      if(!sp_identifier_->hasVariableSet())  {
        resetVectorIdentifier(row);
        break;
      }

      //if the identifier is the master filter the vector
      //NB we do not filter the columns in the case that there is a LHS variable and this is row 1
      //the user can create vectors which do not currently exist in a case
      if(sp_case_->Master == (int)MasterCol::IDENTIFIER) {
        if(!(lhs_variable_present_ && (row == 1)))
          setVectorColumnMenu(true,false,(row == 1 && lhs_variable_present_));
      }

      break;

    default:

      ASSERT(false);

      break;
  }

  //ensure that the rest items are present if a valid item has been selected
  if(sp_identifier_->hasVariableSet())  {
    addResetItem(sp_identifier_->BaseMenu);
  }

  if(sp_vector_->hasVariableSet())  {
    addResetItem(sp_vector_->BaseMenu);
  }

  //set the tooltips for the columns - all columns updated
  //to catch cases where selections are invalid and have been 
  //altered
  style_case_->CellTipText=sp_case_->BaseMenu->getDisplayName();
  style_vector_->CellTipText=sp_vector_->BaseMenu->getDisplayName();
  style_identifier_->CellTipText=sp_identifier_->BaseMenu->getDisplayName();

  clearStyles();
}*/

/*
void 
SumCalMenuTable::propagateAllInFolderSelection(int col)  {

  GridStyleInfo^               style_lhs_row = this[1,col];
  BaseMenuCellStyleProperties^ sp_lhs_row    = gcnew BaseMenuCellStyleProperties(style_lhs_row);
  MenuItemStoredValue^ selected_item = sp_lhs_row->BaseMenu;  
  MenuItemVariable *selected_variable = selected_item->getItemStored();

  //must have rows to propagate to
  if(this->RowCount < 2)
    return;

  for(int i = 2; i <= this->RowCount ; i++) {

    GridStyleInfo^               style_current = this[i,col];
    BaseMenuCellStyleProperties^ sp_current    = gcnew BaseMenuCellStyleProperties(style_current);

    //if the current item is of type FOLDER and does not match the selected item then reset
    //row
    MenuItemVariable *current_variable = sp_current->BaseMenu->getItemStored();
    if(current_variable->getStoredType() == MenuItemVariable::StoredType::FOLDER && !(selected_variable->Equals(*current_variable))) {

      //if this is the case column only set the case column - the selections for vector and identifier
      //will still be valid for any 'All in folder' item
      getStyles(i);
      if(int(SumCols::CASE) == col) {
        setCaseColumnMenu(i);

        //else this is the identifier column, we must reset the vector (as this may be being filtered)
        //and identifier columns but we do not reset the selection of the vector column. 
      }else {
        setVectorColumnMenu(false,false,false);
        setIdentifierColumnMenu(false,true,i);
        sp_case_->Master = (int)MasterCol::NONE;
      }
    }
    sp_current->filterAllInFolderItems(selected_item);
  }

  //we must ensure that the stored styles are recreated. This function is only called from the first row
  //so we reset the styles to row 1
  getStyles(1);
}
*/

/*
//a selection has been made and so we need to add a 'reset' menu item to the combo list. Only add if this 
//does not already exist
void 
SumCalMenuTable::addResetItem(MenuItemStoredValue^ base_menu) {

  //if this has not already been inserted then add...
  if(base_menu->DropDownItems->Count > 0)  {

    MenuItemStoredValue^ current_item = dynamic_cast<MenuItemStoredValue^>(base_menu->DropDownItems[0]);
    if(current_item != nullptr) {

      if(!(current_item->getItemStored()->getStoredType() == MenuItemVariable::StoredType::RESET)) {

        VarParser^ parser         = gcnew VarParser(menu_combo_active_, COMBO_MENU_HEIGHT, COMBO_MENU_WIDTH);
        MenuItemStoredValue^ reset_item = parser->getResetSelectionMenuItem();
        base_menu->DropDownItems->Insert(0,reset_item);
      }
    }
  }
}
*/

/*
void 
SumCalMenuTable::resetVectorIdentifier(int row)  {
  setVectorColumnMenu(false,true,(row == 1 && lhs_variable_present_));
  setIdentifierColumnMenu(false,true,row);
  sp_case_->Master = (int)MasterCol::NONE;
}
*/

/*
void 
SumCalMenuTable::getStyles(int row)  {
  clearStyles();
  style_case_       = this[row,int(SumCols::CASE)];
  sp_case_          = gcnew BaseMenuCellStyleProperties(style_case_);
  style_vector_     = this[row,int(SumCols::VECTOR)];
  sp_vector_        = gcnew BaseMenuCellStyleProperties(style_vector_);
  style_identifier_ = this[row,int(SumCols::IDENTIFIER)];
  sp_identifier_    = gcnew BaseMenuCellStyleProperties(style_identifier_);
}
*/

/*
void 
SumCalMenuTable::clearStyles()  {
  style_vector_     = nullptr;
  sp_vector_        = nullptr;
  style_identifier_ = nullptr;
  sp_identifier_    = nullptr;
  style_case_       = nullptr;
  sp_case_          = nullptr;
}
*/

/*
void 
SumCalMenuTable::setCaseColumnMenu(int row)  {

  VarParser^ parser;

  bool lhs_row =  (row == 1) && (lhs_variable_present_);

  //if a LHS variable we wish to offer case options, otherwise simulation options
  if(lhs_row) {
    CaseVarParser^ parser_case = gcnew CaseVarParser(menu_combo_active_, COMBO_MENU_HEIGHT, COMBO_MENU_WIDTH);
    parser_case->setShowAllInItems(true);
    parser = dynamic_cast<VarParser^>(parser_case);

    ASSERT(parser != nullptr);
    if(parser == nullptr) {
      return;
    }
  }
  else  {
    parser = gcnew SimulationVarParser(menu_combo_active_, COMBO_MENU_HEIGHT, COMBO_MENU_WIDTH);
  }

  parser->setInWorkflow(is_workflow_);

  sp_case_->BaseMenu = parser->getBaseMenuItem(current_case_filter_);

  //if this is the LHS row and there is a LHS vector variable - not always the case if
  //producing a scaler number
  if(lhs_row)  {
    sp_case_->BaseMenu->DropDownItems->Insert(0,parser->getNewActionMenuItem());
  }

  //must do this after adding the 'New' menu item otherwise the 'new' menu item 
  //will not have a click event due to the change in parser
  parser = gcnew SourceDataVarParser(menu_combo_active_, COMBO_MENU_HEIGHT, COMBO_MENU_WIDTH);
  MenuItemStoredValue^ source_data = parser->getBaseMenuItem(current_case_filter_);
  if(!lhs_row)  {
    if(source_data != nullptr)  {
      if(source_data->DropDownItems->Count > 0)  {
        while(source_data->DropDownItems->Count > 0)  {
          sp_case_->BaseMenu->DropDownItems->Add(source_data->DropDownItems[0]);
        }
      }
    }
  }

  //if in the workflow then we must also add the list of variables to the options
  if(is_workflow_)  {
    parser = gcnew VariableVarParser(menu_combo_active_, COMBO_MENU_HEIGHT, COMBO_MENU_WIDTH);

    MenuItemStoredValue^ variable_items = parser->getBaseMenuItem();
    if(variable_items != nullptr)  {
      if(variable_items->DropDownItems->Count > 0)  {
        while(variable_items->DropDownItems->Count > 0)  {
          sp_case_->BaseMenu->DropDownItems->Add(variable_items->DropDownItems[0]);
        }
      }
    }
  }

  //apply the 'all in folder...' filter if there is a lhs present and this is not the first row
  if(lhs_variable_present_ && row != 1) {

    GridStyleInfo^ lhs_style_case = this[1, (int)SumCols::CASE];
    BaseMenuCellStyleProperties^ lhs_sp_case = gcnew BaseMenuCellStyleProperties(lhs_style_case);
    GridStyleInfo^ this_style_case = this[row, (int)SumCols::CASE];
    BaseMenuCellStyleProperties^ this_sp_case = gcnew BaseMenuCellStyleProperties(this_style_case);
    this_sp_case->filterAllInFolderItems(lhs_sp_case->BaseMenu);
  }
}
*/
/*
void 
SumCalMenuTable::setVectorColumnMenu(bool filter_column, bool clear_selection,bool new_vector_option)  {


  MenuItemStoredValue^ base_menu;

  //if the column is not enabled then create an empty base menu item
  if(!style_vector_->Enabled) {

    VarParser ^ parser = gcnew VarParser();
    base_menu = parser->getBaseMenuItem();

  }else {

    VectorVarParser^ parser = gcnew VectorVarParser(menu_combo_active_, COMBO_MENU_HEIGHT, COMBO_MENU_WIDTH);
    parser->setInWorkflow(is_workflow_);


    bool column_filtered = filter_column && !(sp_case_->BaseMenu->getItemStored()->getStoredType()==MenuItemVariable::StoredType::FOLDER) && !(sp_identifier_->BaseMenu->getItemStored()->getStoredType()==MenuItemVariable::StoredType::FOLDER) && !(sp_case_->BaseMenu->getItemStored()->getStoredType()==MenuItemVariable::StoredType::VARIABLE);

    //obtain the new menu - switch on whether to filter the options on the filter flag and only filter
    //if the case and identifier options are not an 'All in folder' option
    if(column_filtered) {
      base_menu = parser->getBaseMenuItem(sp_case_->BaseMenu->getItemStored(),sp_identifier_->BaseMenu->getItemStored(),false,current_vector_filter_);
    }
    else  {
      base_menu = parser->getBaseMenuItem(false,current_vector_filter_);
    }

    //optionally add a new vector menu item - this occurs if this is the first row and a LHS is present
    if(new_vector_option) {
      base_menu->DropDownItems->Insert(0,parser->getNewActionMenuItem());
    }

    //if we are to retain the previous selection ensure that the combination of vector and identifier
    //yield a result
    bool kept_selection = false;

    if(!clear_selection) {
      if(!column_filtered || parser->hasResult(sp_vector_->BaseMenu->getItemStored()->getGenericPropId())) {
        base_menu->Text = sp_vector_->BaseMenu->Text;
        base_menu->setItemStored(sp_vector_->BaseMenu->getItemStored());
        kept_selection = true;
      }
    }

    if(kept_selection && sp_vector_->hasVariableSet())  {
      addResetItem(base_menu);
    }
  }

  sp_vector_->BaseMenu = base_menu;

}
*/

/*
void 
SumCalMenuTable::setIdentifierColumnMenu(bool filter_column, bool clear_selection,int row)  {

  MenuItemStoredValue^ base_menu;

  //if the column is not enabled then create an empty base menu item
  if(!style_identifier_->Enabled) {

    VarParser ^ parser = gcnew VarParser();
    base_menu = parser->getBaseMenuItem();

  }else {

    IdentifierVarParser^ parser = gcnew IdentifierVarParser(menu_combo_active_, COMBO_MENU_HEIGHT, COMBO_MENU_WIDTH);
    parser->setInWorkflow(is_workflow_);
    parser->setShowAllInItems(true);


    bool column_filtered = filter_column && !(sp_case_->BaseMenu->getItemStored()->getStoredType()==MenuItemVariable::StoredType::FOLDER) && !(sp_case_->BaseMenu->getItemStored()->getStoredType()==MenuItemVariable::StoredType::VARIABLE);

    //obtain the new menu - switch on whether to filter the options on the filter flag and only filter
    //if the case option is not an 'All in folder' or Variable option
    if(column_filtered) {
      MenuItemStoredValue^ vector_base_menu = dynamic_cast<MenuItemStoredValue^>(sp_vector_->BaseMenu);
      MenuItemStoredValue^ case_base_menu = dynamic_cast<MenuItemStoredValue^>(sp_case_->BaseMenu);
      base_menu = parser->getBaseMenuItem(case_base_menu->getItemStored(),vector_base_menu->getItemStored(),current_identifier_filter_);
    }
    else  {
      base_menu = parser->getBaseMenuItem(current_identifier_filter_);
    }

    //if in the workflow then we must also add the list of variables to the options
    if(is_workflow_)  {
      VariableVarParser^ parser = gcnew VariableVarParser(menu_combo_active_, COMBO_MENU_HEIGHT, COMBO_MENU_WIDTH);

      MenuItemStoredValue^ variable_items = parser->getBaseMenuItem();
      if(variable_items != nullptr)  {
        if(variable_items->DropDownItems->Count > 0)  {
          while(variable_items->DropDownItems->Count > 0)  {
            base_menu->DropDownItems->Add(variable_items->DropDownItems[0]);
          }
        }
      }
    }

    //if we are to retain the previous selection ensure that the combination of vector and identifier
    //yield a result

    bool kept_selection = false;

    if(!clear_selection) {
      if(!column_filtered || parser->hasResult(sp_identifier_->BaseMenu->getItemStored()->getGenericCatValue())) {
        base_menu->Text = sp_identifier_->BaseMenu->Text;
        base_menu->setItemStored(sp_identifier_->BaseMenu->getItemStored());
        kept_selection = true;
      }
    }

    if(kept_selection && sp_identifier_->hasVariableSet())  {
      addResetItem(base_menu);
    }
  }

  //set the menu tree 
  sp_identifier_->BaseMenu = base_menu;

  //apply the 'all in folder...' filter if there is a lhs present and this is not the first row
  if(lhs_variable_present_ && row != 1) {

    GridStyleInfo^ lhs_style_iden = this[1, (int)SumCols::IDENTIFIER];
    BaseMenuCellStyleProperties^ lhs_sp_iden = gcnew BaseMenuCellStyleProperties(lhs_style_iden);
    GridStyleInfo^ this_style_iden = this[row, (int)SumCols::IDENTIFIER];
    BaseMenuCellStyleProperties^ this_sp_iden = gcnew BaseMenuCellStyleProperties(this_style_iden);
    this_sp_iden->filterAllInFolderItems(lhs_sp_iden->BaseMenu);
  }
}
*/
void
SumCalMenuTable::initialiseMenuStripControls()  {

  menu_combo_active_ = gcnew ComboMenuStrip();
  menu_combo_draw_ = gcnew ComboMenuStrip();

  menu_combo_active_->AutoSize=false;
  menu_combo_draw_->AutoSize=false;

  menu_combo_active_->Width=CELL_WIDTH;
  menu_combo_draw_->Width=CELL_WIDTH;

  menu_combo_active_->Width=CELL_HEIGHT;
  menu_combo_draw_->Width=CELL_HEIGHT;

  menu_combo_active_->Padding =(System::Windows::Forms::Padding)gcnew System::Windows::Forms::Padding(0);
  menu_combo_draw_->Padding = (System::Windows::Forms::Padding)gcnew System::Windows::Forms::Padding(0);

  menu_combo_active_->setItemOnClick(false);
  menu_combo_draw_->setItemOnClick(false);

  menu_combo_active_->RenderMode = System::Windows::Forms::ToolStripRenderMode::ManagerRenderMode;
  menu_combo_draw_->RenderMode = System::Windows::Forms::ToolStripRenderMode::ManagerRenderMode;
}

//disable both the row and column resizing
System::Void
SumCalMenuTable::gridResizingColumns(System::Object^ sender, Syncfusion::Windows::Forms::Grid::GridResizingColumnsEventArgs^  e) {
  e->Cancel=true;
}
System::Void
SumCalMenuTable::gridResizingRows(System::Object^ sender, Syncfusion::Windows::Forms::Grid::GridResizingRowsEventArgs^  e) {
  e->Cancel=true;
}

//inserts a single row into the table
/*void 
SumCalMenuTable::insertVariableRow() {

  const int nRow=this->RowCount + 1;
  Rows->InsertRange(nRow, 1);
  SetRowHeight(nRow,nRow,CELL_HEIGHT);

  

  //set string in first column
  //makeString(nRow,int(SumCols::VARIABLE),gcnew System::String("Variable to assign"));
  setStyleRange(UiTableRange::cell(nRow, int(SumCols::VARIABLE)), UiTableStyle(nullptr)
    .setDraw3dFrame(UiTableStyle::Draw3dFrame::FrameInset));

  //setString(nRow,int(SumCols::VARIABLE),gcnew System::String(args->getUserName()));
  setStyleRange(UiTableRange::cell(nRow, int(SumCols::VARIABLE)), UiTableStyle(nullptr).setValue(gcnew System::String(args->getUserName())));

  GridStyleInfo^ style;
  style=this[nRow,int(SumCols::VARIABLE)];
  style->Enabled=false;

  //create the menu item cells
  makeComboMenuListRow(nRow);

  //set the initial selection for each cell - if there is a valid item in the args then
  //use this, otherwise search the list of variables stored (in previous_expression) for a matching variable name
  setSelections(nRow,args,previous_expression);

  GridStyleInfo^ style_identifier = this[nRow,int(SumCols::VARIABLE)];
  style_identifier->BackColor = System::Drawing::Color::LightGray;

  //set the master to none for the row
  GridStyleInfo^ style_case = this[nRow,int(SumCols::CASE)];
  BaseMenuCellStyleProperties^ sp = gcnew BaseMenuCellStyleProperties(style_case);
  sp->Master = (int)MasterCol::NONE;

  
}*/
/*const SummaryCalculatorVariable*
SumCalMenuTable::getPreviousMatchingRow(const CString name,const SummaryCalculatorExpression::Ptr previous_expresion) {

  int number_variables = previous_expresion->getNoVariables();

  if(number_variables>0)  {
    for (int i = 0 ; i < number_variables ; i++) {
      const SummaryCalculatorVariable *input_variable = previous_expresion->getVariableAt(i);
      if(input_variable->getUserName() == name) {

        //exit point - return found variable
        return input_variable;
      }
    }
  }

  //exit point - no variable found return null
  return NULL;

}
*/
/*void 
SumCalMenuTable::setSelections(int row, SummaryCalculatorVariable::Ptr args,const SummaryCalculatorExpression::Ptr previous_expresion)  {

  const SummaryCalculatorVariable *variable_to_select = NULL;
  const SummaryCalculatorVariable *previous_row = getPreviousMatchingRow(args->getUserName(), previous_expresion);

  //the logic of selection is that is there is valid input in the row passed in (args) then use this data
  //if this is not valid then use (if found) the row from the previous entry (previous_row). 
  //if this is the first row and the above has failed then search both the input expression and the 
  //previous expression for any data to create a new case or a new vector
  //the case and identifier columns may also be set to a reference variable - in which case we should
  //select the reference variable if we are in the workflow
  //final possibility is that the item selected is an 'All in folder' in which case the folder unique tag will be
  //stored in the case tag of the variable and the appropriate flag set.

  //case selection
  if(args->getCaseTag() != UniqueTag::undef())  {

    variable_to_select = args;
  }
  else if(previous_row != NULL && previous_row->getCaseTag() != UniqueTag::undef()) {

    variable_to_select = previous_row;
  }

  //if we have found a match then set it - otherwise this might be the LHS row and we need to search for
  //any 'New case' data in either the input arg or the stored expression
  if(variable_to_select != NULL)  {
    MenuItemVariable menu_variable;
    menu_variable = MenuItemVariable();

    //test if this is a 'All in folder' tag otherwise if this is a reference subject tag then treat as such
    //if it is a case tag then treat as such
    //otherwise assume it is a flow control/development strategy
    if(variable_to_select->getUseAllInCaseFolder()) {

      menu_variable.setFolderTag(&(variable_to_select->getCaseTag()));

    }else {

      RefFolder *ref_folder = RefFolder::getActive();
      const NamedSubject *named_ref_subject = NULL;
      ASSERT(ref_folder != NULL);
      if(ref_folder != NULL)
        named_ref_subject= ref_folder->getKidByUniqueTagRecursive(variable_to_select->getCaseTag());

      CasesTree *cases_tree = CasesTree::getActive();
      const NamedSubject * case_subject = NULL;
      ASSERT(cases_tree != NULL);
      if(cases_tree != NULL)
        case_subject = cases_tree->getKidByUniqueTagRecursive(variable_to_select->getCaseTag());


      if(named_ref_subject != NULL) {
        menu_variable.setVariableTag(&(variable_to_select->getCaseTag()));
      }
      else if (case_subject != NULL) {
        menu_variable.setUniqueTag(&(variable_to_select->getCaseTag()),variable_to_select->getSourceCat());
      }else
      {
        //this will be either observed data or flow controls.
        //we set the data to case tag - both are handled in the 
        //MenuItemVariable Equals function for both cases
        menu_variable.setUniqueTag(&(variable_to_select->getCaseTag()),variable_to_select->getSourceCat());
      }
    }
    setSelection(row,int(SumCols::CASE),menu_variable);

  } else  {

    if(row == 1 && lhs_variable_present_) {
      //have not found a case tag but there may be new case data to recreate
      if(previous_row != NULL && previous_row->getCaseTag() == UniqueTag::undef())  {
        setNewCaseSelection(previous_expresion);
      }
    }
  }

  //vector selection
  variable_to_select = NULL;
  if(args->getGenericPropId() != NULL)  {

    variable_to_select = args;
  }
  else if(previous_row != NULL && previous_row->getGenericPropId() != NULL) {

    variable_to_select = previous_row;
  }

  //if we have found a match then set it
  //it is possible to have a generic prop id but for this to be new (in workflow)
  //and not yet be on the dynamic results tree
  if(variable_to_select != NULL)  {
    MenuItemVariable menu_variable;
    menu_variable = MenuItemVariable();
    menu_variable.setGenericPropId(variable_to_select->getGenericPropId());
    setSelection(row,int(SumCols::VECTOR),menu_variable);
  } else  {

    //lhs variables only 
    if(row == 1 && lhs_variable_present_) {

      //have not found vector data but there may be new vector data to recreate
      if(previous_expresion->getNewVectorName() != "" && previous_expresion->getNewTemplateTag() != UniqueTag::undef())  {
        setNewVectorSelection(previous_expresion);
      }
    }
  }

  //identifier selection
  variable_to_select = NULL;
  if(args->getIdentifierCat(false) != NULL || args->getIdentifierRefTag() != UniqueTag::undef())  {

    variable_to_select = args;
  }
  else if(previous_row != NULL && (previous_row->getIdentifierCat(false) != NULL || previous_row->getIdentifierRefTag() != UniqueTag::undef())) {

    variable_to_select = previous_row;
  }

  //if we have found a match...
  if(variable_to_select != NULL)  {

    MenuItemVariable menu_variable;
    menu_variable = MenuItemVariable();

    if(variable_to_select->getIdentifierCat(false) != NULL)  {
      menu_variable.setGenericCatValue(variable_to_select->getIdentifierCat(false));
      //must check for 'all in folder' item first as this stores the folder tag in the
      //iden ref tag variable
    }else if(variable_to_select->getUseAllInIdentifierFolder()) {
      menu_variable.setFolderTag(&(variable_to_select->getIdentifierRefTag()));
    }else if(variable_to_select->getIdentifierRefTag() != UniqueTag::undef()) {
      menu_variable.setVariableTag(&(variable_to_select->getIdentifierRefTag()));
    }    

    setSelection(row,int(SumCols::IDENTIFIER),menu_variable);
  }
}

bool
SumCalMenuTable::setNewVectorSelection(const SummaryCalculatorExpression::Ptr expression) {

  if(expression->getNewVectorName() != "" && expression->getNewTemplateTag() != UniqueTag::undef()) {

    BaseMenuCellStyleProperties^ sp;
    GridStyleInfo^ style;
    style=this[1,(int)SumCols::VECTOR]; //we are assured that this will be row 1 as new only applies to the LHS
    sp = gcnew BaseMenuCellStyleProperties(style);

    MenuItemStoredValue^ base_menu = sp->BaseMenu;
    base_menu->Text= gcnew System::String(expression->getNewVectorName());
    base_menu->setDisplayName(gcnew System::String(expression->getNewVectorName()));

    //set the stored variable in the base menu item    
    MenuItemVariable menu_item;
    menu_item = MenuItemVariable();
    NewVectorVariable vector_var = menu_item.getNewVectorVar(); 
    vector_var.setVectorName(expression->getNewVectorName());
    vector_var.setTemplateUniqueTag(expression->getNewTemplateTag());
    menu_item.setNewVectorVar(vector_var);
    base_menu->setItemStored(&menu_item);

    itemSelectedAction(1,(int)SumCols::VECTOR,&menu_item,false);

    return true;
  }
  else  {
    return false;
  }
}

bool
SumCalMenuTable::setNewCaseSelection(const SummaryCalculatorExpression::Ptr expression) {

  const CString name = expression->getNewCaseName();
  if(name != "") {

    BaseMenuCellStyleProperties^ sp;
    GridStyleInfo^ style;
    style=this[1,(int)SumCols::CASE]; //we are assured that this will be row 1 as new only applies to the LHS
    sp = gcnew BaseMenuCellStyleProperties(style);

    MenuItemStoredValue^ base_menu = sp->BaseMenu;
    base_menu->Text= gcnew System::String(expression->getNewCaseName());
    base_menu->setDisplayName(gcnew System::String(expression->getNewCaseName()));

    //set the stored variable in the base menu item    
    MenuItemVariable menu_item;
    menu_item = MenuItemVariable();
    NewCaseVariable case_var = menu_item.getNewCaseVar(); 
    case_var.setCaseName(expression->getNewCaseName());
    case_var.setFolderName(expression->getNewCaseFolder());
    case_var.setRefCaseUniqueTag(expression->getNewCaseRefTag());
    menu_item.setNewCaseVar(case_var);
    base_menu->setItemStored(&menu_item);

    itemSelectedAction(1,(int)SumCols::CASE,&menu_item,false);

    return true;
  }
  else  {
    return false;
  }
}


bool 
SumCalMenuTable::setSelection(int row,int col, MenuItemVariable menu_variable) {
  BaseMenuCellStyleProperties^ sp;
  GridStyleInfo^ style;
  style=this[row,col];

  //it is possible to select vectors and identifiers for a LHS variable and then change the expression to make this a RHS variable
  //in which case we will be setting a vec and iden for disabled columns - ideally these columns would be enabled but this is unlikely so simply 
  //do not set these
  if(style->Enabled == false)
    return true;

  sp = gcnew BaseMenuCellStyleProperties(style);
  bool selected = sp->setSelection(menu_variable);

  if(selected) 
    itemSelectedAction(row, col, &menu_variable, false);

  return selected;
}
*/

